# Load in the appropriate values from the results of the expert elicitation

load("MW_mature_Days.robj"); matureDays <- temp
# although disturbance will not affect juvenile or dependent minke whales, 
# we need initial values for the relevant functions
juveDays <- temp 
dependentDays <- temp
load ("output_matureMW_290113.robj")
matureSurvival_2_10kHz <- output_mature$Survival_2_10kHz
matureSurvival_2_10kHz$X <- matureSurvival_2_10kHz$X*100
matureReproduction_2_10kHz <- output_mature$Reproduction_2_10kHz
matureReproduction_2_10kHz$X <- matureReproduction_2_10kHz$X*100
# again, although juveniles and dependents will not be exposed we need values for the functions
juvenileSurvival_2_10kHz <- output_mature$Survival_2_10kHz
dependentSurvival_2_10kHz <- output_mature$Survival_2_10kHz

pmean <- round(pmean*propfemale)

Fert <- rep(0, 6)
Fert[1] <- Fertility/2.0

# determine initial stable age structure for population from Leslie matrix

  L                  <- array(0, dim = c(10, 10))
  L[1, age2]          <- Fert[1] * Surv[7]
  L[1, (age2 + 1):10] <- Fert[1] * Surv[13]
  index3             <- array(c(2:(age1+1), 1:age1), dim = c( age1 ,2) )
  L[index3]            <- Surv[1]
  mature             <- ifelse(age2 == 9, 9, age2 + 1)
  index1             <- array(c((mature + 1):10, (mature):9), dim = c((10 - mature), 2))
  L[index1]          <- Surv[13]
  L[10, 10]          <- Surv[13]
  index2             <- array(c((age1+2):(age2 + 1), (age1+1):age2), dim = c((age2 - age1), 2))
  L[index2]          <- Surv[7]
  
  
  ev              <- eigen(L)

    # ev$val[1] contains growth rate of the undisturbed population
  
  evCmplx         <- ev # in case we need this later on
# age_structure holds the proportion of animals in each age class for a stable age structure  
  age_structure   <- as.numeric(ev$vec[1:10, 1] / (sum(ev$vec[1:10, 1])))


# set % level of environmental variation for calf survival, juvenile survival and fecundity from expert elicitation results
EnvStoch <- c(25, 30, 25)
# calculate standard deviations that will result in lower 99% CL matching environmental variation
SDs <- EnvStoch/(3*100)
mu <- Surv[c(1,7)]
mu[3] <- Fertility
# calculate parameters of Beta distribution to match these values for mu and SD
a <- 0
b <- 0
  for (ibeta in 1:3){
    b[ibeta] <- mu[ibeta]*(1-mu[ibeta])^2/SDs[ibeta]^2 + mu[ibeta] - 1
    a[ibeta] <- mu[ibeta]*b[ibeta]/(1-mu[ibeta])
    }


# newvulnmean includes proportion of animals in undisturbed remainder of population, if there is one!
  newvulnmean <- vulnmean
  if(sum(vulnmean)== 1){newvulnmean <- newvulnmean} else {newvulnmean[nvulnmean+1] <- 1 - sum(newvulnmean)}

# if pile_years is zero, there is no need to process "pile" 
if (pile_years > 0) {
  
# read csv file with schedule of piling activities
pile <- read.csv(file = piling.file, header = TRUE)
  
# remove day labels from first column of csv file
library(stringr)
yvec   <- str_match(colnames(pile), 'Operation')
npiles <- length(yvec[!is.na(yvec)])
pilesx <- which(str_match(colnames(pile), 'Operation') %in% 'Operation') # remove any unwanted columns, i.e. row names that come over from excel
pile  <- pile[, pilesx, drop = FALSE]
pilesx <- which(str_match(colnames(pile), 'Operation') %in% 'Operation') # repeat to get the vector dimensions correct.

# check that number of piling operations specified in config matches number in piling file
if(pilesx1 != ncol(pile)){stop('Number of Piling Operations do not match')}

# check that number of days in piling file is an exact multiple of 365
if(nrow(pile)/365 != pile_years){stop('Number of days in piling file is not an exact multiple of 365')}

# add extra days to beginning of piling schedule so that animals are exposed to disturbance from 
# 1 June in year before piling starts to 31 May in first year of piling
for (i_extra in 1:214){pile <- rbind(rep(c(0),npiles),pile)}
# add extra days to end of piling schedule so that animals are exposed to disturbance from 
# 1 June in last year of piling to 31 May in year after piling ends
for (i_extra in 1:151){pile <- rbind(pile,rep(c(0),npiles))}

# template for  piling operations should ensure that number of rows is an exact multiple of 365
pile_years <- nrow(pile) / 365 
# yearvec indicates year number for each day in pile
yearvec <- rep(1:(pile_years), each = 365)

pile <- data.frame(pile, pbdays = rowSums(pile), pvec = rowSums(pile))
# pile$pbdays indicates number of piling events on a particular day, pile$pvec is a flag indicating whether or not piling has occurred
pile$pvec[pile$pvec > 1] <- 1 

# NDt will contains number of animals predicted to be disturbed during 1 day of activity for each piling operation
# NPt will contains number of animals predicted to be disturbed during 1 day of activity for each piling operation
# values are repeated for each day in "pile"
NDt <- matrix(0,nrow(pile), npiles, byrow = TRUE)
NPt <- matrix(0,nrow(pile), npiles, byrow = TRUE)

if (seasons == 1){
  daily_NDt <- matrix(rep(numDt[1,1:npiles]*propfemale,c(365)),nrow = c(365), ncol= npiles, byrow = TRUE)
  daily_NPt <- matrix(rep(numPt[1,1:npiles]*propfemale,c(365)),nrow = c(365), ncol= npiles, byrow = TRUE)
} else {
  day_seq <- c(92,91,90,92)
  N_rows <- c(3,4,1,2)
  daily_NDt <- matrix(rep(numDt[N_rows[1],1:npiles]*propfemale,day_seq[1]),nrow = day_seq[1], ncol= npiles, byrow = TRUE)
  daily_NPt <- matrix(rep(numPt[N_rows[1],1:npiles]*propfemale,day_seq[1]),nrow = day_seq[1], ncol= npiles, byrow = TRUE)
  for (i_season in 2:4){
    temp_NDt <- matrix(rep(numDt[N_rows[i_season],1:npiles]*propfemale,day_seq[i_season]),nrow = day_seq[i_season], ncol= npiles, byrow = TRUE)
    temp_NPt <- matrix(rep(numPt[N_rows[i_season],1:npiles]*propfemale,day_seq[i_season]),nrow = day_seq[i_season], ncol= npiles, byrow = TRUE)
    daily_NDt <- rbind(daily_NDt,temp_NDt)
    daily_NPt <- rbind(daily_NPt,temp_NPt)
  }
}

NDt[,1:npiles]<- do.call(rbind, replicate(pile_years, daily_NDt, simplify=FALSE))
NPt[,1:npiles]<- do.call(rbind, replicate(pile_years, daily_NPt, simplify=FALSE))

#creates a column for each vulnerable sub-population indicating the days on which there is piling that will affect it
for(i in 1:nrow(vulnpile)){
  pvec <- as.matrix(pile[, pilesx]) %*% as.matrix(vulnpile[i, ])
  pvec[pvec > 1] <- 1
  colnames(pvec) <- paste('vuln', i, 'pvec', sep = '')
  pile <- cbind(pile, pvec)              
}

}

NCollisions <- NCollisions*propfemale                                                             

